#ifndef WRAPPER_H
#define WRAPPER_H

#include <inttypes.h>

typedef struct {
  uint32_t edi, esi, ebp, esp, ebx, edx, ecx, eax;
} reg386_t;

typedef int (*wrapper_func_t)(void *stack_base, int stack_size, reg386_t *reg,  uint32_t *flags);

extern wrapper_func_t report_entry __asm__("report_entry"), report_ret __asm__("report_ret");

extern void (*wrapper_target)(void) __asm__("wrapper_target");

extern int wrapper(void) __asm__("wrapper");
extern int null_call(void) __asm__("null_call");

#endif /* WRAPPER_H */

